/* 
 * fILE:   iniCalGenome.cpp
 * Author: Nan Gao
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fstream>
#include <iostream>
#include "AjacencyGraphy.h"
#include "DcjDistance.h"
#include "GaOperation.h"
using namespace std;

void iniCalGenome(geNome *genome, int geLen, char *filePath)
{
    int gene = 0;
    int count = 0;
    int genLen = 2*geLen;
    int tempGe = 0;
    
    
    idAndPos *tempArray ;
    tempArray = new idAndPos[genLen + 2];
	tempArray[0].id = 0;
	tempArray[0].pos = 0;
    int *inPutGene;
    inPutGene = new int[genLen/2];
    
    ifstream fin(filePath);// || 
    while (!fin.eof())
    {
       for(int i = 0; i < genLen/2; i++)
       {
		  
           fin >> gene;
           inPutGene[i] = gene;
           count++;
       }
    }
    fin.close();  
    
    int tindex = 1;
    for (int i = 0; i < genLen/2; i++)
    {
        tempGe = inPutGene[i];
        if (tempGe > 0)
        {
            tempArray[tindex].id = 2*tempGe - 1;
						tempArray[tindex].pos = tindex;
            tempArray[tindex+1].id = 2*tempGe;
						tempArray[tindex+1].pos = tindex+1;
        }
        if (tempGe < 0)
        {
            tempArray[tindex].id = 2*abs(tempGe);
						tempArray[tindex].pos = tindex;
            tempArray[tindex+1].id = 2*abs(tempGe) - 1;
						tempArray[tindex+1].pos = tindex+1;
        }
        tindex = tindex + 2;
    }
    tempArray[tindex].id = genLen + 1;
		tempArray[tindex].pos = genLen + 1;

    for (int u = 0; u < genLen + 2; u+=2)
    {
        int y1 = tempArray[u].id;
        int y2 = tempArray[u+1].id;
        genome[y1].geneID = tempArray[u].id;
        genome[y1].marked = 0;
        genome[y1].next = tempArray[u+1].id;
				genome[y1].pos = tempArray[u].pos;
        genome[y2].geneID = tempArray[u+1].id;
        genome[y2].marked = 0;
        genome[y2].next = tempArray[u].id;
				genome[y2].pos = tempArray[u+1].pos;
    }
		cout << " done read identity! " << endl;
    //delete
    delete[] tempArray;
    delete[] inPutGene;
    //return genome;
}

