
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "structs.h"
#include "invdist.h"
#include "condense.h"
#include "sorting_reversal_median.h"
#include "lists.h"

void swapGenome(int* genes, int num_genes, int start, int stop);
int tmp[MAX_NUM_GENES];
genome_struct* ASortingSequence(struct genome_struct* g1, struct genome_struct* g2, 
        int num_genes, int totalStep, int stepb, List l, List m) {
	struct genome_struct* ge;// for return genome
	ge = new genome_struct[num_genes];//initial the space for ge
	/*****/
	FILE *f;
    int i,j;
    int idx;
   
    Reversal* r1;
    Reversal* r2;
	//f = fopen ("C:\\temp\\out.txt", "a");
  
	//initial ge's genes if the step # is 0
             
    for (i = 0; i < totalStep; i++) {
         find_all_sorting_reversals(&l, &m, g1, g2,
               num_genes, NULL);

         
/*         clean_list(&m);
         r1 = (Reversal*) pop_queue(&l);
         while (r1 != NULL) {
             
             if ( (r1->stop - r1->start) < 5 && list_size(&l) > 200) {
                 free(r1);
             }
             else push(&m, r1);
             r1 = (Reversal*) pop_queue(&l);
         }*/
         r1 = (Reversal*) list_pick(&l, &idx);
    
         swapGenome(g1->genes, num_genes, r1->start, r1->stop);		 
		
//         free(r1);
         clear_list(&l);
         clear_list(&m);
		 if (i == stepb) break;
    }
	
	/*for ( j = 0; j < num_genes; j++) {
		fprintf(f, "%d ",g1->genes[j]);
	}
	fprintf(f, "\n\r");//for windows
	fclose(f);*/
	/*if (stepb == 0) 
	{
		for ( int j = 0; j < num_genes; j++)
				 ge->genes[j] = g1->genes[j];
	}*/
	return g1;
		 
}

void swapGenome(int* genes, int num_genes, int start, int stop) {
    int i, j;
    if (start < 0 || start >= num_genes) return;
    if (stop < 0 || stop >= num_genes) return;
    if (start >= stop) {
        printf("Start > stop\n");
        exit(-1);
    }

    for (i = start; i < stop; i++) {
        tmp[i] = genes[i];
    }

    j = stop-1;
    for (i = start; i < stop; i++)  {
        genes[i] = 0- tmp[j];
        j--;
    }
    return;
}
