/* 
 * fILE:   DcjOperation.cpp
 * Author: Nan Gao
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>
#include <vector>
#include <time.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include "AjacencyGraphy.h"
#include "GaOperation.h"
#include "DcjDistance.h"

using namespace std;
// for one genome
bool compfunction(idAndPos A, idAndPos B)
{
	return (A.pos < B.pos);
}

void upDateGenome(geNome* gA, int genLen, vector<idAndPos> tempGA)
{
	int id = 0;
	int mark = 0;
	for (int i = 0; i < genLen; i++)
	{
		id = tempGA[i].id;
		mark = tempGA[i].change;
		gA[id].marked = mark;
	}
}

vector<idAndPos> transGe(geNome *gA, int genLen)
{
	vector<idAndPos> transGA(genLen);
	for (int i = 0; i < genLen; i++)
	{
		transGA[i].id = gA[i].geneID;
		transGA[i].pos = gA[i].pos;
		transGA[i].change = 0;
	}
	return transGA;
}

void DcjOperation(geNome *gA, geNome* gB, int geLen)
{
	//from gA to gB
	//posGB is the index for tempGB(the position as index)
	//adjGB is the index for gB (the geneID as index)
	vector<idAndPos> tempGA(geLen);
	vector<idAndPos> tempGB(geLen);
	tempGA = transGe(gA, geLen);
	tempGB = transGe(gB, geLen);
	sort(tempGA.begin(), tempGA.end(), compfunction);
	sort(tempGB.begin(), tempGB.end(), compfunction);
	//do dcjOperation
	int posGB = 0;
	int posGA1 = 0;//first postion in gA
	int posGA2 = 0;//second postion in gA
	int posGA3 = 0;//second postion in gA
	int posGA4 = 0;//second postion in gA
	int adjGB1 = 0;//first gene in gB adjacency
	int adjGB2 = 0;//second gene in gB adjacency
	int adjGA1 = 0;
	int adjGA2 = 0;
	int adjGA3 = 0;
	int adjGA4 = 0;
	posGB = (int)rand()%(geLen/2);
	posGB = posGB * 2;
	
	adjGB1 = tempGB[posGB].id;
	adjGB2 = gB[adjGB1].next;
	adjGA1 = adjGB1;
	adjGA2 = gA[adjGA1].next;

	while (adjGA2 == adjGB2)
	{
		//has the same adj
		posGB = (int)rand()%(geLen/2);
		posGB = posGB * 2;
		adjGB1 = tempGB[posGB].id;
		adjGB2 = gB[adjGB1].next;
		adjGA1 = adjGB1;
		adjGA2 = gA[adjGA1].next;
	}
	//gA don't has the same adj
	//then do dcjOperation
	adjGA3 = adjGB2;
	adjGA4 = gA[adjGA3].next;
	//update all the four elements in gA adj graph so they will in the same order as gB
	posGA1 = gA[adjGA1].pos;
	posGA2 = gA[adjGA2].pos;
	posGA3 = gA[adjGA3].pos;
	posGA4 = gA[adjGA4].pos;
	if (posGA1%2 == 0)//for even position GA2 <->GA3
	{
		int tempID = 0;
		tempID = adjGA2;
		tempGA[posGA2].id = adjGA3;
		tempGA[posGA3].id = tempID;
		gA[adjGA2].pos = posGA3;
		gA[adjGA2].next = adjGA4;
		gA[adjGA1].next = adjGA3;
		gA[adjGA3].next = adjGA1;
		gA[adjGA3].pos = posGA2;
		gA[adjGA4].next = adjGA2;
	}
	else //for odd position GA1<->GA4
	{
		int tempID = 0;
		tempID = adjGA1;
		tempGA[posGA1].id = adjGA4;
		tempGA[posGA4].id = tempID;
		gA[adjGA1].next = adjGA3;
		gA[adjGA1].pos = posGA4;
		gA[adjGA3].next = adjGA1;
		gA[adjGA4].next = adjGA2;
		gA[adjGA4].pos = posGA1;
		gA[adjGA2].next = adjGA4;
	}
	
}

