#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "structs.h"
#include "invdist.h"
#include "condense.h"
#include "sorting_reversal_median.h"
#include "lists.h"

void swapGenome1(int* genes, int num_genes, int start, int stop);
int tmp1[MAX_NUM_GENES];
void aSortingSeq(struct genome_struct* g1, struct genome_struct* g2, 
        int num_genes, int totalStep, char *fileOut) {
	/*****/
	FILE *f;
    int i,j;
    int idx;
    List l;
    List m;
    Reversal* r1;
    Reversal* r2;
	f = fopen (fileOut, "a");
    init_list(&l, (num_genes+1)*num_genes, sizeof (Reversal*));
    init_list(&m, (num_genes+1)*num_genes, sizeof (Reversal*));
             
    for (i = 0; i < totalStep; i++) {
		
         find_all_sorting_reversals(&l, &m, g1, g2,
               num_genes, NULL);

         
/*         clean_list(&m);
         r1 = (Reversal*) pop_queue(&l);
         while (r1 != NULL) {
             
             if ( (r1->stop - r1->start) < 5 && list_size(&l) > 200) {
                 free(r1);
             }
             else push(&m, r1);
             r1 = (Reversal*) pop_queue(&l);
         }*/
         r1 = (Reversal*) list_pick(&l, &idx);
		
         swapGenome1(g1->genes, num_genes, r1->start, r1->stop);
		 if( i == totalStep*1/10) 
		 {
			 for ( j = 0; j < num_genes - 1; j++) 
			 {
				 fprintf(f, "%d ",g1->genes[j]);
			 }
			fprintf(f,"%d", g1->genes[num_genes-1]);
			fprintf(f, "\r\n");//for windows
		 }
		
		 if (i == totalStep*1/5)
		 {
			 for ( j = 0; j < num_genes - 1; j++) 
			 {
				 fprintf(f, "%d ",g1->genes[j]);
			 }
			fprintf(f,"%d", g1->genes[num_genes-1]);
			fprintf(f, "\r\n");//for windows
		 }
		 
		 if (i == totalStep*3/10)
		 {
			 for ( j = 0; j < num_genes - 1; j++) 
			 {
				 fprintf(f, "%d ",g1->genes[j]);
			 }
			fprintf(f,"%d", g1->genes[num_genes-1]);
			fprintf(f, "\r\n");//for windows
		 }
		
		 if (i == totalStep*2/5)
		 {
			 for ( j = 0; j < num_genes - 1; j++) 
			 {
				 fprintf(f, "%d ",g1->genes[j]);
			 }
			fprintf(f,"%d", g1->genes[num_genes-1]);
			fprintf(f, "\r\n");//for windows
		 }
		
		 if (i == totalStep*1/2)
		 {
			 for ( j = 0; j < num_genes - 1; j++) 
			 {
				 fprintf(f, "%d ",g1->genes[j]);
			 }
			fprintf(f,"%d", g1->genes[num_genes-1]);
			fprintf(f, "\r\n");//for windows
		 }
		
		 if (i == totalStep*3/5)
		 {
			 for ( j = 0; j < num_genes - 1; j++) 
			 {
				 fprintf(f, "%d ",g1->genes[j]);
			 }
			fprintf(f,"%d", g1->genes[num_genes-1]);
			fprintf(f, "\r\n");//for windows
		 }
//         free(r1);
         clean_list(&l);
         clean_list(&m);
    }
		
	fclose(f);
	return;
		 
}

void swapGenome1(int* genes, int num_genes, int start, int stop) {
    int i, j;
    if (start < 0 || start >= num_genes) return;
    if (stop < 0 || stop >= num_genes) return;
    if (start >= stop) {
        printf("Start > stop\n");
        exit(-1);
    }

    for (i = start; i < stop; i++) {
        tmp1[i] = genes[i];
    }

    j = stop-1;
    for (i = start; i < stop; i++)  {
        genes[i] = 0- tmp1[j];
        j--;
    }
    return;
}
