/* 
 * fILE:   initialGenome.cpp
 * Author: Nan Gao
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <fstream>
#include <iostream>
#include "AjacencyGraphy.h"
#include "DcjDistance.h"
#include "GaOperation.h"
using namespace std;

geNome **iniGenome (int pop, int geLen, char *filePath)//suppose need to be 2*geLen for each genome struct
{
    int gene = 0;
    int count = 0;
    int popNum = pop;
    int genLen = 2*geLen;
    int tempGe = 0;
    idAndPos *tempArray;
    tempArray = new idAndPos[genLen + 2];
	tempArray[0].id = 0;
	tempArray[0].pos = 0;
    int **inPutGene = NULL;
    inPutGene = new int *[popNum];
    for (int i = 0; i < popNum; i++)
    {
        inPutGene[i] = new int[genLen/2];
    }
    
    //return genome pool
    geNome **oriGenome = NULL;
    oriGenome = new geNome *[popNum];
    for (int i = 0; i < popNum; i++)
    {
        oriGenome[i] = new geNome[genLen + 2];
    }

    ifstream fin(filePath);//space separate
    while (!fin.eof())
    {
        for(int i = 0; i < popNum; i++)
            for (int j = 0; j < genLen/2 ; j++)
            {
				if (count >= popNum*genLen/2) {i = popNum; break;}
                fin >> gene;
                inPutGene[i][j] = gene;
                count++;
            }  
		if (count >= popNum*genLen/2) break;
    }
    fin.close();

    //process the inPutGene
    int tindex = 1;
    for (int i = 0; i < popNum; i++)
    {
        for (int j =0; j < genLen/2; j++)
        {
            tempGe = inPutGene[i][j];
            if (tempGe > 0)
            {
							tempArray[tindex].id = 2*tempGe - 1;
							tempArray[tindex].pos = tindex;
							tempArray[tindex+1].id = 2*tempGe;
							tempArray[tindex+1].pos = tindex+1;
            }
            if (tempGe < 0)
            {
							tempArray[tindex].id = 2*abs(tempGe);
							tempArray[tindex].pos = tindex;
							tempArray[tindex+1].id = 2*abs(tempGe) - 1;
							tempArray[tindex+1].pos = tindex+1;
            }
            tindex = tindex + 2;
        }
       tempArray[tindex].id = genLen + 1;
	   	 tempArray[tindex].pos = genLen + 1;
        //put in hash position
        for (int u = 0; u < genLen+2; u+=2)
        {               
					int y1 = tempArray[u].id;
					int y2 = tempArray[u+1].id;
					oriGenome[i][y1].geneID = tempArray[u].id;
					oriGenome[i][y1].pos = tempArray[u].pos;
					oriGenome[i][y1].next = tempArray[u+1].id;
					oriGenome[i][y2].geneID = tempArray[u+1].id;
					oriGenome[i][y2].pos = tempArray[u+1].pos;
				  oriGenome[i][y1].marked = 0;
				  oriGenome[i][y2].next = tempArray[u].id;
          oriGenome[i][y2].marked = 0;
        }
        tindex = 1;
     }
    //delete
    delete[] tempArray;
    for (int i = 0; i < popNum; i++)
    {
        delete inPutGene[i];
        inPutGene[i] = NULL;
    }
    delete[] inPutGene;
    inPutGene = NULL;

    return oriGenome;
    //delete
    for (int i = 0; i < popNum; i++)
    {
        delete oriGenome[i];
        oriGenome[i] = NULL;
    }
    delete[] oriGenome;
    oriGenome = NULL;    
}

